=encoding utf8

=head1 NAME

Mail::Box::MH - handle MH folders

=head1 INHERITANCE

 Mail::Box::MH
   is a Mail::Box::Dir
   is a Mail::Box
   is a Mail::Reporter

=head1 SYNOPSIS

 use Mail::Box::MH;
 my $folder = new Mail::Box::MH folder => $ENV{MAIL}, ...;

=head1 DESCRIPTION

This documentation describes how MH mailboxes work, and what you
can do with the MH folder object C<Mail::Box::MH>.

Extends L<"DESCRIPTION" in Mail::Box::Dir|Mail::Box::Dir/"DESCRIPTION">.
 
=head1 OVERLOADED

Extends L<"OVERLOADED" in Mail::Box::Dir|Mail::Box::Dir/"OVERLOADED">.
 
=over 4

=item overload: B<"">

Inherited, see L<Mail::Box/"OVERLOADED">

=item overload: B<@{}>

Inherited, see L<Mail::Box/"OVERLOADED">

=item overload: B<cmp>

Inherited, see L<Mail::Box/"OVERLOADED">

=back

=head1 METHODS

Extends L<"METHODS" in Mail::Box::Dir|Mail::Box::Dir/"METHODS">.
 
=head2 Constructors

Extends L<"Constructors" in Mail::Box::Dir|Mail::Box::Dir/"Constructors">.
 
=over 4

=item Mail::Box::MH-E<gt>B<new>(%options)

 -Option           --Defined in     --Default
  access             Mail::Box        'r'
  body_delayed_type  Mail::Box        Mail::Message::Body::Delayed
  body_type          Mail::Box        Mail::Message::Body::Lines
  coerce_options     Mail::Box        []
  create             Mail::Box        <false>
  directory          Mail::Box::Dir   <derived from folder name>
  extract            Mail::Box        10240
  field_type         Mail::Box        undef
  fix_headers        Mail::Box        <false>
  folder             Mail::Box        $ENV{MAIL}
  folderdir          Mail::Box        $ENV{HOME}/.mh
  head_delayed_type  Mail::Box        Mail::Message::Head::Delayed
  head_type          Mail::Box        Mail::Message::Head::Complete
  index                               undef
  index_filename                      <foldername>/.index
  index_type                          Mail::Box::MH::Index
  keep_dups          Mail::Box        <false>
  keep_index                          0
  labels                              undef
  labels_filename                     <foldername>/.mh_sequence
  labels_type                         Mail::Box::MH::Labels
  lock_file          Mail::Box        <index_file>
  lock_timeout       Mail::Box        1 hour
  lock_type          Mail::Box        Mail::Box::Locker::DotLock
  lock_wait          Mail::Box        10 seconds
  locker             Mail::Box        undef
  log                Mail::Reporter   'WARNINGS'
  manager            Mail::Box        undef
  message_type       Mail::Box        <folder-class>::Message
  multipart_type     Mail::Box        Mail::Message::Body::Multipart
  remove_when_empty  Mail::Box        <true>
  save_on_exit       Mail::Box        <true>
  trace              Mail::Reporter   'WARNINGS'
  trusted            Mail::Box        <depends on folder location>

=over 2

=item access => MODE

=item body_delayed_type => CLASS

=item body_type => CLASS|CODE

=item coerce_options => ARRAY

=item create => BOOLEAN

=item directory => DIRECTORY

=item extract => INTEGER | CODE | METHOD | 'LAZY'|'ALWAYS'

=item field_type => CLASS

=item fix_headers => BOOLEAN

=item folder => FOLDERNAME

=item folderdir => DIRECTORY

=item head_delayed_type => CLASS

=item head_type => CLASS

=item index => OBJECT

You may specify an OBJECT of a type which extends L<Mail::Box::MH::Index|Mail::Box::MH::Index>
(at least implements a C<get()> method), as alternative for an index file
reader as created by C<Mail::Box::MH>.

=item index_filename => FILENAME

The FILENAME which is used in each directory to store the headers of all
mails. The filename shall not contain a directory path. (e.g. Do not use
C</usr/people/jan/.index>, nor C<subdir/.index>, but say C<.index>.)

=item index_type => CLASS

=item keep_dups => BOOLEAN

=item keep_index => BOOLEAN

Keep an index file of the specified mailbox, one file per directory.
Using an index file will speed up things considerably, because it avoids
reading all the message files the moment that you open the folder.  When
you open a folder, you can use the index file to retrieve information such
as the subject of each message, instead of having to read possibly
thousands of messages.

=item labels => OBJECT

You may specify an OBJECT of a type which extends L<Mail::Box::MH::Labels|Mail::Box::MH::Labels>
(at least implements the C<get()> method), as alternative for labels file
reader as created by C<Mail::Box::MH>.

=item labels_filename => FILENAME

In MH-folders, messages can be labeled, for instance based on the
sender or whether it is read or not.  This status is kept in a
file which is usually called C<.mh_sequences>, but that name can
be overruled with this flag.

=item labels_type => CLASS

=item lock_file => FILENAME

=item lock_timeout => SECONDS

=item lock_type => CLASS|STRING|ARRAY

=item lock_wait => SECONDS

=item locker => OBJECT

=item log => LEVEL

=item manager => MANAGER

=item message_type => CLASS

=item multipart_type => CLASS

=item remove_when_empty => BOOLEAN

=item save_on_exit => BOOLEAN

=item trace => LEVEL

=item trusted => BOOLEAN

=back

=back

=head2 The folder

Extends L<"The folder" in Mail::Box::Dir|Mail::Box::Dir/"The folder">.
 
=over 4

=item $obj-E<gt>B<addMessage>($message, %options)

Inherited, see L<Mail::Box/"The folder">

=item $obj-E<gt>B<addMessages>(@messages)

Inherited, see L<Mail::Box/"The folder">

=item Mail::Box::MH-E<gt>B<appendMessages>(%options)

Append a message to a folder which is not open.

 -Option  --Defined in     --Default
  folder    Mail::Box        <required>
  message   Mail::Box        undef
  messages  Mail::Box        undef
  share     Mail::Box        <false>

=over 2

=item folder => FOLDERNAME

=item message => MESSAGE

=item messages => ARRAY-OF-MESSAGES

=item share => BOOLEAN

=back

=item $obj-E<gt>B<close>(%options)

Inherited, see L<Mail::Box/"The folder">

=item $obj-E<gt>B<copyTo>($folder, %options)

Inherited, see L<Mail::Box/"The folder">

=item $obj-E<gt>B<delete>(%options)

Inherited, see L<Mail::Box/"The folder">

=item $obj-E<gt>B<directory>()

Inherited, see L<Mail::Box::Dir/"The folder">

=item $obj-E<gt>B<folderdir>( [$directory] )

Inherited, see L<Mail::Box/"The folder">

=item $obj-E<gt>B<name>()

Inherited, see L<Mail::Box/"The folder">

=item $obj-E<gt>B<organization>()

Inherited, see L<Mail::Box/"The folder">

=item $obj-E<gt>B<size>()

Inherited, see L<Mail::Box/"The folder">

=item $obj-E<gt>B<type>()

Inherited, see L<Mail::Box/"The folder">

=item $obj-E<gt>B<update>(%options)

Inherited, see L<Mail::Box/"The folder">

=item $obj-E<gt>B<url>()

Inherited, see L<Mail::Box/"The folder">

=back

=head2 Folder flags

Extends L<"Folder flags" in Mail::Box::Dir|Mail::Box::Dir/"Folder flags">.
 
=over 4

=item $obj-E<gt>B<access>()

Inherited, see L<Mail::Box/"Folder flags">

=item $obj-E<gt>B<isModified>()

Inherited, see L<Mail::Box/"Folder flags">

=item $obj-E<gt>B<modified>( [BOOLEAN] )

Inherited, see L<Mail::Box/"Folder flags">

=item $obj-E<gt>B<writable>()

Inherited, see L<Mail::Box/"Folder flags">

=back

=head2 The messages

Extends L<"The messages" in Mail::Box::Dir|Mail::Box::Dir/"The messages">.
 
=over 4

=item $obj-E<gt>B<current>( [$number|$message|$message_id] )

Inherited, see L<Mail::Box/"The messages">

=item $obj-E<gt>B<find>($message_id)

Inherited, see L<Mail::Box/"The messages">

=item $obj-E<gt>B<findFirstLabeled>( $label, [BOOLEAN, [$msgs]] )

Inherited, see L<Mail::Box/"The messages">

=item $obj-E<gt>B<message>( $index, [$message] )

Inherited, see L<Mail::Box/"The messages">

=item $obj-E<gt>B<messageId>( $message_id, [$message] )

Inherited, see L<Mail::Box/"The messages">

=item $obj-E<gt>B<messageIds>()

Inherited, see L<Mail::Box/"The messages">

=item $obj-E<gt>B<messages>( <'ALL'|$range|'ACTIVE'|'DELETED'|$label| !$label|$filter> )

Inherited, see L<Mail::Box/"The messages">

=item $obj-E<gt>B<nrMessages>(%options)

Inherited, see L<Mail::Box/"The messages">

=item $obj-E<gt>B<scanForMessages>($message, $message_ids, $timespan, $window)

Inherited, see L<Mail::Box/"The messages">

=back

=head2 Sub-folders

Extends L<"Sub-folders" in Mail::Box::Dir|Mail::Box::Dir/"Sub-folders">.
 
=over 4

=item $obj-E<gt>B<listSubFolders>(%options)

=item Mail::Box::MH-E<gt>B<listSubFolders>(%options)

Inherited, see L<Mail::Box/"Sub-folders">

=item $obj-E<gt>B<nameOfSubFolder>( $subname, [$parentname] )

=item Mail::Box::MH-E<gt>B<nameOfSubFolder>( $subname, [$parentname] )

Inherited, see L<Mail::Box/"Sub-folders">

=item $obj-E<gt>B<openRelatedFolder>(%options)

Inherited, see L<Mail::Box/"Sub-folders">

=item $obj-E<gt>B<openSubFolder>($subname, %options)

Inherited, see L<Mail::Box/"Sub-folders">

=item $obj-E<gt>B<topFolderWithMessages>()

=item Mail::Box::MH-E<gt>B<topFolderWithMessages>()

Inherited, see L<Mail::Box/"Sub-folders">

=back

=head2 Internals

Extends L<"Internals" in Mail::Box::Dir|Mail::Box::Dir/"Internals">.
 
=over 4

=item $obj-E<gt>B<coerce>($message, %options)

Inherited, see L<Mail::Box/"Internals">

=item $obj-E<gt>B<create>($foldername, %options)

=item Mail::Box::MH-E<gt>B<create>($foldername, %options)

 -Option   --Defined in--Default
  folderdir  Mail::Box   undef

=over 2

=item folderdir => DIRECTORY

=back

=item $obj-E<gt>B<determineBodyType>($message, $head)

Inherited, see L<Mail::Box/"Internals">

=item $obj-E<gt>B<folderToDirectory>($foldername, $folderdir)

Inherited, see L<Mail::Box::Dir/"Internals">

=item Mail::Box::MH-E<gt>B<foundIn>( [$foldername], %options )

Inherited, see L<Mail::Box/"Internals">

=item $obj-E<gt>B<highestMessageNumber>()

Returns the highest number which is used in the folder to store a file.
This method may be called when the folder is read (then this number can
be derived without file-system access), but also when the folder is not
read (yet).

=item $obj-E<gt>B<index>()

Create a index reader/writer object.

=item $obj-E<gt>B<labels>()

Create a label reader/writer object.

=item $obj-E<gt>B<lineSeparator>( [<STRING|'CR'|'LF'|'CRLF'>] )

Inherited, see L<Mail::Box/"Internals">

=item $obj-E<gt>B<locker>()

Inherited, see L<Mail::Box/"Internals">

=item $obj-E<gt>B<read>(%options)

Inherited, see L<Mail::Box/"Internals">

=item $obj-E<gt>B<readMessageFilenames>($directory)

Inherited, see L<Mail::Box::Dir/"Internals">

=item $obj-E<gt>B<readMessages>(%options)

Inherited, see L<Mail::Box/"Internals">

=item $obj-E<gt>B<storeMessage>($message)

Inherited, see L<Mail::Box/"Internals">

=item $obj-E<gt>B<toBeThreaded>($messages)

Inherited, see L<Mail::Box/"Internals">

=item $obj-E<gt>B<toBeUnthreaded>($messages)

Inherited, see L<Mail::Box/"Internals">

=item $obj-E<gt>B<updateMessages>(%options)

Inherited, see L<Mail::Box/"Internals">

=item $obj-E<gt>B<write>(%options)

Inherited, see L<Mail::Box/"Internals">

=item $obj-E<gt>B<writeMessages>(%options)

 -Option  --Defined in     --Default
  messages  Mail::Box        <required>
  renumber                   <true>

=over 2

=item messages => ARRAY

=item renumber => BOOLEAN

Permit renumbering of message.  By default this is true, but for some
unknown reason, you may be thinking that messages should not be renumbered.

=back

=back

=head2 Other methods

Extends L<"Other methods" in Mail::Box::Dir|Mail::Box::Dir/"Other methods">.
 
=over 4

=item $obj-E<gt>B<timespan2seconds>($time)

=item Mail::Box::MH-E<gt>B<timespan2seconds>($time)

Inherited, see L<Mail::Box/"Other methods">

=back

=head2 Error handling

Extends L<"Error handling" in Mail::Box::Dir|Mail::Box::Dir/"Error handling">.
 
=over 4

=item $obj-E<gt>B<AUTOLOAD>()

Inherited, see L<Mail::Reporter/"Error handling">

=item $obj-E<gt>B<addReport>($object)

Inherited, see L<Mail::Reporter/"Error handling">

=item $obj-E<gt>B<defaultTrace>( [$level]|[$loglevel, $tracelevel]|[$level, $callback] )

=item Mail::Box::MH-E<gt>B<defaultTrace>( [$level]|[$loglevel, $tracelevel]|[$level, $callback] )

Inherited, see L<Mail::Reporter/"Error handling">

=item $obj-E<gt>B<errors>()

Inherited, see L<Mail::Reporter/"Error handling">

=item $obj-E<gt>B<log>( [$level, [$strings]] )

=item Mail::Box::MH-E<gt>B<log>( [$level, [$strings]] )

Inherited, see L<Mail::Reporter/"Error handling">

=item $obj-E<gt>B<logPriority>($level)

=item Mail::Box::MH-E<gt>B<logPriority>($level)

Inherited, see L<Mail::Reporter/"Error handling">

=item $obj-E<gt>B<logSettings>()

Inherited, see L<Mail::Reporter/"Error handling">

=item $obj-E<gt>B<notImplemented>()

Inherited, see L<Mail::Reporter/"Error handling">

=item $obj-E<gt>B<report>( [$level] )

Inherited, see L<Mail::Reporter/"Error handling">

=item $obj-E<gt>B<reportAll>( [$level] )

Inherited, see L<Mail::Reporter/"Error handling">

=item $obj-E<gt>B<trace>( [$level] )

Inherited, see L<Mail::Reporter/"Error handling">

=item $obj-E<gt>B<warnings>()

Inherited, see L<Mail::Reporter/"Error handling">

=back

=head2 Cleanup

Extends L<"Cleanup" in Mail::Box::Dir|Mail::Box::Dir/"Cleanup">.
 
=over 4

=item $obj-E<gt>B<DESTROY>()

Inherited, see L<Mail::Box/"Cleanup">

=back

=head1 DETAILS

Extends L<"DETAILS" in Mail::Box::Dir|Mail::Box::Dir/"DETAILS">.
 
=head2 Different kinds of folders

Extends L<"Different kinds of folders" in Mail::Box::Dir|Mail::Box::Dir/"Different kinds of folders">.
 
=head2 Available folder types

Extends L<"Available folder types" in Mail::Box::Dir|Mail::Box::Dir/"Available folder types">.
 
=head2 Folder class implementation

Extends L<"Folder class implementation" in Mail::Box::Dir|Mail::Box::Dir/"Folder class implementation">.
 
=head2 How MH folders work

MH-type folders use a directory to store the messages of one folder.  Each
message is stored in a separate file.  This seems useful, because changes
in a folder change only a few of these small files, in contrast with
file-based folders where changes in a folder cause rewrites of huge
folder files.

However, MH-based folders perform very bad if you need header information
of all messages.  For instance, if you want to have full knowledge about
all message-threads (see L<Mail::Box::Thread::Manager|Mail::Box::Thread::Manager>) in the folder, it
requires to read all header lines in all message files.  And usually, reading
your messages in threads is desired.

So, each message is written in a separate file.  The filenames are
numbers, which count from C<1>.  Next to these message files, a
directory may contain a file named C<.mh_sequences>, storing labels which
relate to the messages.  Furthermore, a folder-directory may contain
sub-directories, which are seen as sub-folders.

=head2 This implementation

This implementation supports the C<.mh-sequences> file and sub-folders.
Next to this, considerable effort it made to avoid reading each message-file.
This should boost performance of the MailBox distribution over other
Perl-modules which are able to read folders.

Folder types which store their messages each in one file, together in
one directory, are bad for performance.  Consider that you want to know
the subjects of all messages, while browser through a folder with your
mail-reading client.  This would cause all message-files to be read.

L<Mail::Box::MH|Mail::Box::MH> has two ways to try improve performance.  You can use
an index-file, and use on delay-loading.  The combination performs even
better.  Both are explained in the next sections.

=head2 An index-file

If you specify L<new(keep_index)|Mail::Box::MH/"METHODS">, then all header-lines of all messages
from the folder which have been read once, will also be written into
one dedicated index-file (one file per folder).  The default filename
is C<.index>

However, index-files are not supported by any other reader which supports
MH (as far as I know).  If you read the folders with such I client, it
will not cause unrecoverable conflicts with this index-file, but at most
be bad for performance.

If you do not (want to) use an index-file, then delay-loading may
save your day.

=head1 DIAGNOSTICS

=over 4

=item Error: Cannot append message without lock on $folder.

It is impossible to append one or more messages to the folder which is
not opened, because locking it fails.  The folder may be in use by
an other application, or you may need to specify some lock related
options (see L<new()|Mail::Box::MH/"METHODS">).

=item Error: Cannot create MH folder $name: $!

For some reason, it is impossible to create the folder.  Check the permissions
and the name of the folder.  Does the path to the directory to be created
exist?

=item Error: Cannot write folder $name without lock.

It is impossible to get a lock on the folder, which means that the changes
can not be made.  You may need to tune the lock related options which
are available at folder creation.

=item Warning: Changes not written to read-only folder $self.

You have opened the folder read-only --which is the default set
by L<new(access)|Mail::Box/"Constructors">--, made modifications, and now want to close it.
Set L<close(force)|Mail::Box/"The folder"> if you want to overrule the access mode, or close
the folder with L<close(write)|Mail::Box/"The folder"> set to C<NEVER>.

=item Error: Copying failed for one message.

For some reason, for instance disc full, removed by external process, or
read-protection, it is impossible to copy one of the messages.  Copying will
proceed for the other messages.

=item Error: Destination folder $name is not writable.

The folder where the messages are copied to is not opened with write
access (see L<new(access)|Mail::Box/"Constructors">).  This has no relation with write permission
to the folder which is controlled by your operating system.

=item Warning: Different messages with id $msgid

The message id is discovered more than once within the same folder, but the
content of the message seems to be different.  This should not be possible:
each message must be unique.

=item Error: Folder $name is opened read-only

You can not write to this folder unless you have opened the folder to
write or append with L<new(access)|Mail::Box/"Constructors">, or the C<force> option is set true.

=item Error: Folder $name not deleted: not writable.

The folder must be opened with write access via L<new(access)|Mail::Box/"Constructors">, otherwise
removing it will be refused.  So, you may have write-access according to
the operating system, but that will not automatically mean that this
C<delete> method permits you to.  The reverse remark is valid as well.

=item Error: Invalid timespan '$timespan' specified.

The string does not follow the strict rules of the time span syntax which
is permitted as parameter.

=item Warning: Message-id '$msgid' does not contain a domain.

According to the RFCs, message-ids need to contain a unique random part,
then an C<@>, and then a domain name.  This is made to avoid the creation
of two messages with the same id.  The warning emerges when the C<@> is
missing from the string.

=item Error: Package $package does not implement $method.

Fatal error: the specific package (or one of its superclasses) does not
implement this method where it should. This message means that some other
related classes do implement this method however the class at hand does
not.  Probably you should investigate this and probably inform the author
of the package.

=item Error: Unable to create subfolder $name of $folder.

The copy includes the subfolders, but for some reason it was not possible
to copy one of these.  Copying will proceed for all other sub-folders.

=item Error: Unable to write message for $folder to $filename: $!

The new message could not be written to its new file, for the specific
reason.

=item Error: Writing folder $name failed

For some reason (you probably got more error messages about this problem)
it is impossible to write the folder, although you should because there
were changes made.

=back

=head1 SEE ALSO

This module is part of Mail-Box distribution version 3.008,
built on October 04, 2019. Website: F<http://perl.overmeer.net/CPAN/>

=head1 LICENSE

Copyrights 2001-2019 by [Mark Overmeer]. For other contributors see ChangeLog.

This program is free software; you can redistribute it and/or modify it
under the same terms as Perl itself.
See F<http://dev.perl.org/licenses/>

